float progress(float start, float end, float percent){
  return start + ((end - start) * percent);
}


////////////////////////// Position & Animation Variables

float friction = 0.95;

float x_velocity = - 1;
float x_position = -180;
float x_offset = - 1;
float x_refresh = -180;

float y_velocity = - 1;
float y_position = -30;
float y_offset = - 1;
float y_refresh = -30;

float percentage = 0;


////////////////////////////////////Background
void loadBackground(){

general_map=loadImage ("venice_map-01.jpg");


}

void updateBackground(){
  if(mousePressed){ 
    x_velocity = (mouseX + x_offset) - x_position;
    x_position = mouseX + x_offset;
    y_velocity = (mouseY + y_offset) - y_position;
    y_position = mouseY + y_offset;
  }
  else{
    x_velocity = x_velocity * friction;
    x_position = x_position + x_velocity;
    y_velocity = y_velocity * friction;
    y_position = y_position + y_velocity;
  } 

  /////////////////////////////////stoppig edges////////////////////////
  if (x_position > 0){
    x_position = 0;
  }
  if (x_position < (- 1180)){
    x_position = - 1180;
  }
  if (y_position > 0){
    y_position = 0;
  }
  if (y_position < (- 580)){
    y_position = - 580;
  }
}


void drawBackground(){
  image (general_map, x_position, y_position);


}


void movetocenter() {
  if(x_position != -320 || y_position != -480) {
    x_velocity = (x_refresh - x_position) * 0.054;
    y_velocity = (y_refresh - y_position) * 0.054;
  }
}


void mousePressedBackground(){
  if((mouseX > x_position - 1600)&&(mouseX <  x_position + 1600)){
    x_offset = x_position - mouseX;
  }
  if (mouseY > y_position - 1440 && mouseY <  y_position + 1440){
    y_offset = y_position - mouseY;
  }
}

